#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

char Stroka[80];

struct Ukaz
{
   char Key;  //.
   int Count; // p  p
              //p p.
   int Flag;  //:
              //1 -  . p p;
              //-1 -  .   p.
   int Uroven;//p  (0 - p).
   Ukaz* Prev;//  p  .
              //p "p" -
              //p (   p p!)
   Ukaz* Left;
   Ukaz* Right;
};

class Tree
{
  private:
    Ukaz* Root; //   .
    void Urovni (Ukaz*, int);
    void LinBraRecord (Ukaz*, int, char (*)[]);
  public:
    Tree () { //pp   p.
              Root = new (Ukaz); Root->Right = NULL;};
    void PrintTree (Ukaz*, int);
    void Search (char);
    void Nat (Ukaz*, char (*)[]);
    Ukaz* GetTree() {return Root;};
};

// ------------    ----------

void Tree::Urovni (Ukaz* w, int l)
{
  char Stroka1[80];

  if  (w!=NULL)
  {
	 w->Uroven = l;
	 itoa(w->Uroven,Stroka1,10);
	 // pp p p.  p
	 //    pp 
	 // p.
	 strcat(Stroka,Stroka1);
	 Urovni (w->Left,l+1);
	 Urovni (w->Right,l+1);
  }
}

void Tree::PrintTree (Ukaz* W, int l)
{
  int i;

  if  (W!=NULL)
  {
	 PrintTree (W->Right,l+1);
	 for (i=1;i<=l;i++) cout << "   ";
	 cout << W->Key << endl;
	 PrintTree (W->Left,l+1);
  }
}

void Tree::Search (char x)
{
  Ukaz *p1,*p2;
  int d;

  p2 = Root; p1 = p2->Right; d = 1;
  while  (p1!=NULL && d!=0)
  {
	  p2 = p1;
	  if  (x < p1->Key)
		{ p1 = p1->Left; d = -1; }
	  else
            if  (x > p1->Key) { p1 = p1->Right; d = 1; }
            else  d = 0;
  }
  if  (d==0) p1->Count += 1;
  else
  {
	 p1 = new (Ukaz);
	 p1->Key = x; p1->Left = p1->Right = NULL; p1->Count = 1;
	 if  (d<0)
	 {
		 p2->Left = p1;
		 //  -  p.
		 p1->Flag = -1;
		 //    p  .
		 p1->Prev = p2;
	 }
	 else
	 {
		 p2->Right = p1;
		 //  - p p.
		 p1->Flag = 1;
		 //    p  .
		 p1->Prev = p2;
	 }
  }
}

void Tree::Nat (Ukaz* Root, char (*LSZ)[])
{
  int q1,q2;
  char A[2]; A[1]='\0';

  strcpy(Stroka,"0"); // p.
  Urovni (Root->Right,0); /***/
  strcat(Stroka,"0");
  cout <<" -------------------------------------- \n";
  LinBraRecord (Root->Right,0,&(*LSZ));/***/
  //   ...
  A[0] = Stroka[0];
  q1 = atoi(A);
  A[0] = Stroka[1];
  q2 = atoi(A);
  for(int i=1;i<=abs(q1-q2)-1;i++) strcat((*LSZ),")"); cout << endl;
  // ... p ... }
  if (!strcmp(Stroka,"00"))
  {
	  int z = strlen(*LSZ);
	  (*LSZ)[z-1] = '\0';
  }
  cout << "  ... " << *LSZ << endl;
}

void Tree::LinBraRecord (Ukaz* w, int l, char (*LSZ)[])
{
  int i,q1,q2;
  char A[2]; A[1]='\0';

  if (w!=NULL)
  {
	 //   Uroven  "p" ...
	 A[0] = Stroka[0];
	 //    Uroven   ...
	 int z = strlen(Stroka);
	 for (int j=0;j<z;j++) Stroka[j] = Stroka[j+1];
	 Stroka[z-1] = '\0';
	 //     p  
	 //    ,   p
	 //   p  p p...
	 q1 = atoi(A);
	 A[0] = Stroka[0];
	 q2 = atoi(A);
	 for(i=1;i<=abs(q1-q2)-1;i++) strcat(*LSZ,")");
	 // --------------------------------------------------
	 //  ""    ...
	 // p      -
	 //    "p", p -
	 //     p .
	 //  "p"     p-
	 //  ,     p
	 //     !
	 if  (w->Right==NULL && w->Left==NULL)
	 //    ...
		 if (w->Flag==1) //   - p p...
			if (w->Prev->Left!=NULL) //    p
			{  //  p;
				A[0] = w->Key;
				strcat(*LSZ,A);
				strcat(*LSZ,")");
			}
			else  //   p...
			{
				A[0] = ' ';
				strcat(*LSZ,A);
				A[0] = w->Key;
				strcat(*LSZ,A);
				strcat(*LSZ,")");
			}
		 else  //   -  p...
		  if  (w->Prev->Right!=NULL)
		  { //   p p.
			 A[0] = w->Key;
			 strcat(*LSZ,A);
		  }
		  else
		  {
			 A[0] = w->Key;
			 strcat(*LSZ,A);
			 strcat(*LSZ,")");
		  }
	 else  //    .
	 {
		A[0] = w->Key;
		strcat(*LSZ,A);
		strcat(*LSZ,"(");
	 }
	 LinBraRecord (w->Left,l+1,&(*LSZ));
	 LinBraRecord (w->Right,l+1,&(*LSZ));
  }
}

void main()
{
   Tree A;
   char k;
   char LSZ[80];
   //   p pp "p" p...                       
   //                            -----                                
   //                             *  Root                           
   //                            -----                                
   //            ----+-------+-----v---+-----------------    
   //            Key Count       *            
   //            ----+-------+-----+-+-+-----------------             
   //                                 Root^.Right                    
   //            ----+-------+-----+-v-+-----------------             
   //            Key Count   *   *       p    
   //            ----+-------+--+--+-+-+-----------------             
   // Root^.Right^.Left ---------    -------- Root^.Right^.Right     
   //                   v                    v                        
   //                  ...                  ...                       
   // pp p      p...
   cin >> k;
   while (k!='#')
   {
    A.Search (k);
    cin >> k;
   }
   cout << endl;
   A.PrintTree (A.GetTree()->Right,0);
   // ------------------------------
   strcpy(LSZ,"");
   A.Nat (A.GetTree(),&LSZ); /***/
   //  p    p
   // p    pp
   // ()  pp,   "/***/"
   // (,    !)
}
